{
  "openapi": "3.1.0",
  "info": {
    "description": "HPE Greenlake for File Storage REST APIs",
    "license": {
      "name": "HPE End User License Agreement",
      "url": "https://www.hpe.com/us/en/software/licensing.html"
    },
    "title": "HPE Greenlake for File Storage REST APIs",
    "version": "1.0.0"
  },
  "servers": [
    {
      "url": "https://eu1.data.cloud.hpe.com"
    },
    {
      "url": "https://us1.data.cloud.hpe.com"
    },
    {
      "url": "https://jp1.data.cloud.hpe.com"
    }
  ],
  "tags": [
    {
      "description": "Refers to a collection of file shares. A file share is a specific folder in a filesystem. It includes that folder's subfolders, which can be made accessible to clients via protocols like NFS and SMB.",
      "name": "file-shares"
    },
    {
      "description": "Refers to a collection of filesystems.",
      "name": "file-systems"
    },
    {
      "description": "File share settings APIs",
      "name": "fileshare-settings"
    },
    {
      "description": "Refers to a collection of file shares. A file share is a specific folder in a filesystem. It includes that folder's subfolders, which can be made accessible to clients via protocols like NFS and SMB.",
      "name": "fileshares"
    },
    {
      "description": "Refers to a collection of filesystems.",
      "name": "filesystems"
    }
  ],
  "paths": {
    "/file-storage/v1alpha1/devtype4-storage-systems/{systemId}/file-shares": {
      "get": {
        "description": "List all file shares on the HPE Alletra MP B10000 storage system identified by `{systemId}`. Use `limit`, `offset`, `select`, `filter`, and `sort` to control the results.",
        "operationId": "FileSharesList",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "$ref": "#/components/parameters/limit"
          },
          {
            "$ref": "#/components/parameters/offset"
          },
          {
            "$ref": "#/components/parameters/select"
          },
          {
            "allowReserved": true,
            "description": "Filters the resources returned by the API.\nThe filter expression compares a property with a literal value. The following comparison operators are supported:\n- `eq`: Equals. Supported for number, boolean, and string properties.\n- `gt`: Greater than. Supported for number and timestamp properties.\n- `lt`: Less than. Supported for number and timestamp properties.\n- `in`: Checks whether a value exists in an array of strings.\nSupported properties:\n- `protocol`\n- `state`\n- `generation`\n- `id`\nExamples:\n- `GET /file-storage/v1alpha1/devtype4-storage-systems/{systemId}/file-shares?filter=name eq 'FS1'`\n",
            "in": "query",
            "name": "filter",
            "schema": {
              "type": "string"
            }
          },
          {
            "allowReserved": true,
            "description": "A comma-separated list of properties to sort by, followed by a direction\nindicator (\"asc\" or \"desc\"). If no direction indicator is specified the\ndefault order is ascending.\nSorting is supported for the following attributes:\n* path\n* name\n* state\n* protocol\n* createdAt\n* fileSystemName\n* settingsName\nExample: GET /file-storage/v1alpha1/devtype4-storage-systems/{systemId}/file-shares?sort=name desc\n",
            "in": "query",
            "name": "sort",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ArcusFileshareList"
                }
              }
            },
            "description": "Success"
          },
          "304": {
            "description": "Not Modified"
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "file shares object not found"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "List all file shares on HPE Alletra MP B10000 Storage System identified by {systemId}",
        "tags": [
          "fileshares"
        ]
      },
      "post": {
        "description": "Create a file share on the HPE Alletra MP B10000 storage system identified by `{systemId}`. The response includes a task URI in the `Location` header that you can use to monitor the operation.",
        "operationId": "DeviceType4FileshareCreate",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ArcusShareCreateRequest"
              }
            }
          },
          "required": true
        },
        "responses": {
          "202": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/taskResponse"
                }
              }
            },
            "description": "Accepted. The response includes a task URI in the `Location` header that you can use to monitor the operation.",
            "headers": {
              "Location": {
                "description": "This contains the URI of the task used to monitor the request",
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Create file share for HPE Alletra MP B10000 Storage System identified by {systemId}",
        "tags": [
          "fileshares"
        ]
      }
    },
    "/file-storage/v1alpha1/devtype4-storage-systems/{systemId}/file-shares/{fileShareId}": {
      "delete": {
        "description": "Delete a file share identified by `{fileShareId}` from the HPE Alletra MP B10000 storage system identified by `{systemId}`. This operation removes the associated filesystem and share settings. The response includes a task URI in the `Location` header that you can use to monitor the operation.",
        "operationId": "FileSharesDelete",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "$ref": "#/components/parameters/fileshareUid"
          }
        ],
        "responses": {
          "202": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/taskResponse"
                }
              }
            },
            "description": "Accepted. The response includes a task URI in the `Location` header that you can use to monitor the operation.",
            "headers": {
              "Location": {
                "description": "This contains the URI of the task used to monitor the request",
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request."
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Response while trying to delete a non-existing file share."
          },
          "405": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Method not allowed."
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Delete file share identified by {fileShareId} from HPE Alletra MP B10000 storage system identified by {systemId}.",
        "tags": [
          "fileshares"
        ]
      },
      "get": {
        "description": "Fetch details of the file share identified by `{fileShareId}` on the HPE Alletra MP B10000 storage system identified by `{systemId}`.",
        "operationId": "FileSharesGet",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "$ref": "#/components/parameters/fileshareUid"
          }
        ],
        "responses": {
          "200": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ArcusFileShareDetails"
                }
              }
            },
            "description": "Success"
          },
          "304": {
            "description": "Not Modified"
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Storage system object not found"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Fetch details of a file share identified by {fileShareId} on HPE Alletra MP B10000 storage system identified by {systemId}",
        "tags": [
          "fileshares"
        ]
      },
      "patch": {
        "description": "Update the file share identified by `{fileShareId}` on the HPE Alletra MP B10000 storage system identified by `{systemId}`. The response includes a task URI in the `Location` header that you can use to monitor the operation.",
        "operationId": "DeviceType4FileshareUpdate",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "$ref": "#/components/parameters/fileshareUid"
          }
        ],
        "requestBody": {
          "content": {
            "application/merge-patch+json": {
              "schema": {
                "$ref": "#/components/schemas/ArcusShareUpdateRequest"
              }
            }
          },
          "description": "Request body to update file share",
          "required": true
        },
        "responses": {
          "202": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/taskResponse"
                }
              }
            },
            "description": "Accepted. The response includes a task URI in the `Location` header that you can use to monitor the operation.",
            "headers": {
              "Location": {
                "description": "This contains the URI of the task used to monitor the request",
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Update file share identified by {fileShareId} on HPE Alletra MP B10000 storage system identified by {systemId}",
        "tags": [
          "fileshares"
        ]
      }
    },
    "/file-storage/v1alpha1/devtype4-storage-systems/{systemId}/filesystems": {
      "get": {
        "description": "List all the filesystems on HPE Alletra MP B10000 Storage System identified by {systemId}",
        "operationId": "FileSystemsList",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "$ref": "#/components/parameters/limit"
          },
          {
            "$ref": "#/components/parameters/offset"
          },
          {
            "allowReserved": true,
            "description": "The filter query parameter is used to filter the set of resources returned in the response.\nThe returned set of resources must match the criteria in the filter query parameter.\nA comparison compares a property name to a literal. The comparisons supported are the following:\n* “eq” : Is a property equal to value. Valid for number, boolean and string properties.\n* “gt” : Is a property greater than a value. Valid for number or string timestamp properties.\n* “lt” : Is a property less than a value. Valid for number or string timestamp properties\n* “in” : Is a value in a property (that is an array of strings)\nExamples:\nGET /file-storage/v1alpha1/devtype4-storage-systems/{systemId}/filesystems?filter=name eq 'FS1'\nFilters are supported on the following attributes:\n* state\n* prov\n* name\n* shareCount\n* id\n* generation\n",
            "in": "query",
            "name": "filter",
            "schema": {
              "type": "string"
            }
          },
          {
            "allowReserved": true,
            "description": "A comma-separated list of properties to sort by, followed by a direction\nindicator (\"asc\" or \"desc\"). If no direction indicator is specified the\ndefault order is ascending.\nSorting is supported for the following attributes:\n* name\n* createdAt\nExample: GET /file-storage/v1alpha1/devtype4-storage-systems/{systemId}/filesystems?sort=name desc\n",
            "in": "query",
            "name": "sort",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ArcusFilesystemsList"
                }
              }
            },
            "description": "Success"
          },
          "304": {
            "description": "Not Modified"
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Filesystem object not found"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "List all the filesystems on the HPE Alletra MP B10000 storage system identified by `{systemId}`.",
        "tags": [
          "filesystems"
        ]
      }
    },
    "/file-storage/v1alpha1/devtype4-storage-systems/{systemId}/filesystems/{filesystemId}": {
      "delete": {
        "description": "Delete the filesystem identified by `{filesystemId}` on the HPE Alletra MP B10000 storage system identified by `{systemId}`. The response includes a task URI in the `Location` header that you can use to monitor the operation.",
        "operationId": "FilesystemsDelete",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "$ref": "#/components/parameters/filesystemUid"
          }
        ],
        "responses": {
          "202": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/taskResponse"
                }
              }
            },
            "description": "Accepted. The response includes a task URI in the `Location` header that you can use to monitor the operation.",
            "headers": {
              "Location": {
                "description": "This contains the URI of the task used to monitor the request",
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request."
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Response while trying to delete a non-existing filesystem."
          },
          "405": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Method not allowed."
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Delete a filesystem identified by {filesystemId} on a HPE Alletra MP B10000 storage system identified by {systemId}",
        "tags": [
          "filesystems"
        ]
      },
      "get": {
        "description": "Fetch details of the filesystem identified by `{filesystemId}` on the HPE Alletra MP B10000 storage system identified by `{systemId}`.",
        "operationId": "FilesystemsGet",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "$ref": "#/components/parameters/filesystemUid"
          }
        ],
        "responses": {
          "200": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ArcusFileSystemDetail"
                }
              }
            },
            "description": "Success"
          },
          "304": {
            "description": "Not Modified"
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "filesystems object not found"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Fetch details of the filesystem identified by `{filesystemId}` on the HPE Alletra MP B10000 storage system identified by `{systemId}`.",
        "tags": [
          "filesystems"
        ]
      }
    },
    "/file-storage/v1alpha1/devtype4-storage-systems/{systemId}/filesystems/{filesystemId}/capacity-history": {
      "get": {
        "description": "Get capacity trend data for the filesystem identified by `{filesystemId}` on HPE Alletra MP B10000 Storage System identified by `{systemId}`. Use the `select`, `range`, and `timeintervalmin` query parameters to refine the request.",
        "operationId": "DeviceType4FilesystemCapacityHistoryGetById",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "$ref": "#/components/parameters/filesystemUid"
          },
          {
            "$ref": "#/components/parameters/select"
          },
          {
            "$ref": "#/components/parameters/range"
          },
          {
            "$ref": "#/components/parameters/timeIntervalMin"
          }
        ],
        "responses": {
          "200": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DevType4FsCapHistoryList"
                }
              }
            },
            "description": "Success"
          },
          "304": {
            "description": "Not Modified"
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "filesystems object not found"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Get filesystem capacity trend data of filesystem identified by {filesystemId} on HPE Alletra MP B10000 Storage System identified by {systemId}",
        "tags": [
          "filesystems"
        ]
      }
    },
    "/file-storage/v1alpha1/devtype4-storage-systems/{systemId}/filesystems/{filesystemId}/performance-history": {
      "get": {
        "description": "Retrieves historical performance metrics for the filesystem identified by `{filesystemId}` on HPE Alletra MP B10000 Storage System identified by `{systemId}`. Use the `select`, `range`, and `timeintervalmin` query parameters to refine the request.",
        "operationId": "DeviceType4FilesystemPerformanceHistoryGetById",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "$ref": "#/components/parameters/filesystemUid"
          },
          {
            "$ref": "#/components/parameters/select"
          },
          {
            "$ref": "#/components/parameters/range"
          },
          {
            "$ref": "#/components/parameters/timeIntervalMin"
          }
        ],
        "responses": {
          "200": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DevType4FsPerfHistoryList"
                }
              }
            },
            "description": "Success"
          },
          "304": {
            "description": "Not Modified"
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Storage system object not found"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Get performance trend data of filesystem identified by {filesystemId} on HPE Alletra MP B10000 Storage System identified by {systemId}",
        "tags": [
          "filesystems"
        ]
      }
    },
    "/file-storage/v1alpha1/devtype4-storage-systems/{systemId}/share-settings": {
      "get": {
        "description": "List all share settings on the HPE Alletra MP B10000 storage system identified by `{systemId}`. Use `limit`, `offset`, `filter`, `sort`, and `reconcile` to control the results.",
        "operationId": "ShareSettingsList",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "allowReserved": true,
            "description": "Filters the resources returned by the API.\nThe filter expression compares a property with a literal value. The following comparison operators are supported:\n- `eq`: Equals. Supported for number, boolean, and string properties.\n- `gt`: Greater than. Supported for number and timestamp properties.\n- `lt`: Less than. Supported for number and timestamp properties.\n- `in`: Checks whether a value exists in an array of strings.\nSupported properties:\n- `id`\n- `name`\n- `generation`\n- `shareCount`\nExamples:\n- `GET /file-storage/v1alpha1/devtype4-storage-systems/{systemId}/share-settings?filter=id eq '04e3479f1449267b149eaa2678e7fb99'`\n- `GET /file-storage/v1alpha1/devtype4-storage-systems/{systemId}/share-settings?filter=name eq 'TestShareSetting'`\n",
            "in": "query",
            "name": "filter",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "$ref": "#/components/parameters/limit"
          },
          {
            "$ref": "#/components/parameters/offset"
          },
          {
            "allowReserved": true,
            "description": "A comma-separated list of properties to sort by, followed by a direction\nindicator (\"asc\" or \"desc\"). If no direction indicator is specified the\ndefault order is ascending.\nSorting is supported for the following attributes:\n* name\n* createdAt\nExample: GET /file-storage/v1alpha1/devtype4-storage-systems/{systemId}/share-settings?sort=name desc\n",
            "in": "query",
            "name": "sort",
            "schema": {
              "type": "string"
            }
          },
          {
            "description": "When true, the API will reconcile the share count of the filesystems.",
            "in": "query",
            "name": "reconcile",
            "schema": {
              "type": "boolean"
            }
          }
        ],
        "responses": {
          "200": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ArcusShareSettingsList"
                }
              }
            },
            "description": "Success"
          },
          "304": {
            "description": "Not Modified"
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Share settings object not found"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "List all the share-settings associated on HPE Alletra MP B10000 storage system identified by {systemId}",
        "tags": [
          "fileshare-settings"
        ]
      }
    },
    "/file-storage/v1alpha1/devtype4-storage-systems/{systemId}/share-settings/{sharesettingsId}": {
      "get": {
        "description": "Fetch details of the share settings identified by `{sharesettingsId}` on the HPE Alletra MP B10000 storage system identified by `{systemId}`.",
        "operationId": "ShareSettingsGet",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "$ref": "#/components/parameters/sharesettingsUid"
          }
        ],
        "responses": {
          "200": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ArcusShareSettingsDetails"
                }
              }
            },
            "description": "Success"
          },
          "304": {
            "description": "Not Modified"
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Share settings object not found"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Fetch details of a share-settings identified by {sharesettingsId} on HPE Alletra MP B10000 storage system identified by {systemId}",
        "tags": [
          "fileshare-settings"
        ]
      }
    },
    "/file-storage/v1alpha1/devtype7-storage-systems/{systemId}/file-shares": {
      "description": "This path handles all the following file share CRUD operations:\n- GET all file shares on HPE Alletra Storage X10000 system\n- CREATE a specific file share on a HPE Alletra Storage X10000 system",
      "get": {
        "operationId": "DeviceType7FileSharesListBySystemId",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "$ref": "#/components/parameters/limit"
          },
          {
            "$ref": "#/components/parameters/offset"
          },
          {
            "$ref": "#/components/parameters/select"
          },
          {
            "allowReserved": true,
            "description": "The expression to use for filtering responses.\nFiltering is supported on the below properties:\n- `protocol`\n- `state`\n- `generation`\n- `id`\n- `path`\n- `filesystemId`\n",
            "in": "query",
            "name": "filter",
            "schema": {
              "type": "string"
            }
          },
          {
            "description": "A comma separated list of properties to sort by, followed by a direction\nindicator (\"asc\" or \"desc\"). If no direction indicator is specified the\ndefault order is ascending.\nSorting is supported for the following attributes:\n- `path`\n- `state`\n- `protocol`\n- `createdAt`\n- `updatedAt`\nExample: GET /file-storage/v1alpha1/devtype7-storage-systems/{systemId}/file-shares?sort=path desc\n",
            "example": "path desc",
            "in": "query",
            "name": "sort",
            "schema": {
              "default": "path asc",
              "maxLength": 50,
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HomefleetFileshareList"
                }
              }
            },
            "description": "Success"
          },
          "304": {
            "description": "Not Modified"
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "file shares object not found"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Get all file shares on HPE Alletra Storage X10000 system",
        "tags": [
          "file-shares"
        ]
      },
      "post": {
        "description": "Create a file share on an HPE Alletra Storage X10000 system. The response includes a task URI in the `Location` header that you can use to monitor the operation.",
        "operationId": "DeviceType7FileshareCreate",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/HomefleetShareCreateRequest"
              }
            }
          },
          "required": true
        },
        "responses": {
          "202": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/taskResponse"
                }
              }
            },
            "description": "Accepted",
            "headers": {
              "Location": {
                "description": "This contains the URI of the task used to monitor the request",
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Create Fileshare for a HPE Alletra Storage X10000 system",
        "tags": [
          "file-shares"
        ]
      }
    },
    "/file-storage/v1alpha1/devtype7-storage-systems/{systemId}/file-shares/{fileShareId}": {
      "delete": {
        "description": "This API endpoint deletes the specified file share on an HPE Alletra Storage X10000 system. The response includes a task URI in the `Location` header that you can use to monitor the operation.",
        "operationId": "DeviceType7FileShareDeleteById",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "description": "Unique identifier of the file share",
            "in": "path",
            "name": "fileShareId",
            "required": true,
            "schema": {
              "format": "uuid",
              "type": "string"
            }
          },
          {
            "allowReserved": true,
            "description": "Delete underlying filesystem",
            "example": true,
            "in": "query",
            "name": "delete-filesystem",
            "required": false,
            "schema": {
              "type": "boolean"
            }
          }
        ],
        "responses": {
          "202": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/taskResponse"
                }
              }
            },
            "description": "Accepted",
            "headers": {
              "Location": {
                "description": "This contains the URI of the task used to monitor the request",
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request."
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Response while trying to delete a non-existing file share."
          },
          "405": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Method not allowed."
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "DELETE Fileshare on a HPE Alletra Storage X10000 system",
        "tags": [
          "file-shares"
        ]
      },
      "description": "This path handles all the following file share operations on a HPE Alletra Storage X10000 system:\n- GET a specific file share\n- DELETE a specific file share\n- PATCH a specific file share",
      "get": {
        "operationId": "DeviceType7FileShareGetById",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "description": "Unique identifier of the file share",
            "in": "path",
            "name": "fileShareId",
            "required": true,
            "schema": {
              "format": "uuid",
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HomefleetFileShareDetails"
                }
              }
            },
            "description": "Success"
          },
          "304": {
            "description": "Not Modified"
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Storage system object not found"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Get a specific file share",
        "tags": [
          "file-shares"
        ]
      },
      "patch": {
        "description": "Update the file share on an HPE Alletra Storage X10000 system. The response includes a task URI in the `Location` header that you can use to monitor the operation.",
        "operationId": "DeviceType7FileshareUpdate",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "description": "Unique identifier of the file share",
            "in": "path",
            "name": "fileShareId",
            "required": true,
            "schema": {
              "format": "uuid",
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/merge-patch+json": {
              "schema": {
                "$ref": "#/components/schemas/HomefleetShareUpdateRequest"
              }
            }
          },
          "description": "Request to update file share",
          "required": true
        },
        "responses": {
          "202": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/taskResponse"
                }
              }
            },
            "description": "Accepted",
            "headers": {
              "Location": {
                "description": "This contains the URI of the task used to monitor the request",
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Update Fileshare on a HPE Alletra Storage X10000 system",
        "tags": [
          "file-shares"
        ]
      }
    },
    "/file-storage/v1alpha1/devtype7-storage-systems/{systemId}/filesystems": {
      "description": "This path handles all the following filesystem operations on a HPE Alletra Storage X10000 system:\n- GET all filesystems on a HPE Alletra Storage X10000 system",
      "get": {
        "operationId": "DeviceType7FileSystemsListBySystemId",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "$ref": "#/components/parameters/limit"
          },
          {
            "$ref": "#/components/parameters/offset"
          },
          {
            "$ref": "#/components/parameters/select"
          },
          {
            "allowReserved": true,
            "description": "The expression to use for filtering responses.\n\nFiltering is supported on the below properties:\n- `state`\n- `name`\n- `id`\n- `shareCount`\n- `hardLimitInBytes`\n- `softLimitInBytes`\n",
            "example": "GET /file-storage/v1alpha1/devtype7-storage-systems/{systemId}/filesystems?filter=name eq \"fs1\"",
            "in": "query",
            "name": "filter",
            "schema": {
              "type": "string"
            }
          },
          {
            "description": "A comma separated list of properties to sort by, followed by a direction\nindicator (\"asc\" or \"desc\"). If no direction indicator is specified the\ndefault order is ascending.\nSorting is supported for the following attributes:\n- `state`\n- `name`\n- `shareCount`\n- `createdAt`\n- `updatedAt`\n- `hardLimitInBytes`\n- `softLimitInBytes`\nExample: GET /file-storage/v1alpha1/devtype7-storage-systems/{systemId}/filesystems?sort=name desc\n",
            "example": "id desc",
            "in": "query",
            "name": "sort",
            "schema": {
              "default": "name asc",
              "maxLength": 50,
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HomefleetGetFilesystemsBySystemId"
                }
              }
            },
            "description": "Success"
          },
          "304": {
            "description": "Not Modified"
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Filesystem object not found"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Get all filesystems on a HPE Alletra Storage X10000 system",
        "tags": [
          "file-systems"
        ]
      }
    },
    "/file-storage/v1alpha1/devtype7-storage-systems/{systemId}/filesystems/{filesystemId}": {
      "delete": {
        "description": "This API endpoint deletes the specified filesystem on a HPE Alletra Storage X10000 system.\n",
        "operationId": "DeviceType7FileSystemDeleteById",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "description": "Unique identifier of the filesystem",
            "in": "path",
            "name": "filesystemId",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "202": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/taskResponse"
                }
              }
            },
            "description": "Accepted",
            "headers": {
              "Location": {
                "description": "This contains the URI of the task used to monitor the request",
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request."
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Response while trying to delete a non-existing filesystem."
          },
          "405": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Method not allowed."
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Delete a filesystem on a HPE Alletra Storage X10000 system",
        "tags": [
          "file-systems"
        ]
      },
      "description": "This path handles all the following filesystem CRUD operations:\n- GET a specific filesystem on HPE Alletra Storage X10000 system\n- DELETE a specific filesystem on HPE Alletra Storage X10000 system",
      "get": {
        "operationId": "DeviceType7FileSystemsGetById",
        "parameters": [
          {
            "description": "SystemUid/Serial Number of the array",
            "in": "path",
            "name": "systemId",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "description": "Unique identifier of the filesystem",
            "in": "path",
            "name": "filesystemId",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/HomefleetFilesystemDetails"
                }
              }
            },
            "description": "Success"
          },
          "304": {
            "description": "Not Modified"
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "filesystems object not found"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Get a specific filesystem",
        "tags": [
          "file-systems"
        ]
      }
    },
    "/file-storage/v1alpha1/devtype7-storage-systems/{systemId}/filesystems/{filesystemId}/capacity-history": {
      "get": {
        "description": "Retrieves historical capacity metrics for the filesystem identified by `{filesystemId}` on an HPE Alletra Storage X10000 system. Use the `select`, `range`, and `timeintervalmin` query parameters to refine the request.",
        "operationId": "DeviceType7FilesystemCapacityHistoryGetById",
        "parameters": [
          {
            "description": "SystemUid/Serial Number of the array",
            "in": "path",
            "name": "systemId",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "description": "Unique identifier of the filesystem",
            "in": "path",
            "name": "filesystemId",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "$ref": "#/components/parameters/select"
          },
          {
            "$ref": "#/components/parameters/range"
          },
          {
            "$ref": "#/components/parameters/timeIntervalMin"
          }
        ],
        "responses": {
          "200": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DevType7FsCapHistoryList"
                }
              }
            },
            "description": "Success"
          },
          "304": {
            "description": "Not Modified"
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "filesystems object not found"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "unexpected error"
          }
        },
        "summary": "Get filesystem capacity trend data of a Filesystem identified by {filesystemId} on a HPE Alletra Storage X10000 system",
        "tags": [
          "file-systems"
        ]
      }
    },
    "/file-storage/v1alpha1/devtype7-storage-systems/{systemId}/filesystems/{filesystemId}/performance-history": {
      "get": {
        "description": "Retrieves historical performance metrics for the filesystem identified by `{filesystemId}` on an HPE Alletra Storage X10000 system. Use the `select`, `range`, and `timeintervalmin` query parameters to refine the request.",
        "operationId": "DeviceType7VolumePerformanceHistoryGetById",
        "parameters": [
          {
            "$ref": "#/components/parameters/storageSystemUid"
          },
          {
            "description": "Unique identifier of the filesystem",
            "in": "path",
            "name": "filesystemId",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "$ref": "#/components/parameters/select"
          },
          {
            "$ref": "#/components/parameters/range"
          },
          {
            "$ref": "#/components/parameters/timeIntervalMin"
          }
        ],
        "responses": {
          "200": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DevType7FsPerfHistoryList"
                }
              }
            },
            "description": "Success"
          },
          "304": {
            "description": "Not Modified"
          },
          "400": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Bad Request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unauthorized"
          },
          "403": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Forbidden"
          },
          "404": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Storage system object not found"
          },
          "500": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Internal or unexpected error"
          },
          "503": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Appliance in maintenance mode"
          },
          "default": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                }
              }
            },
            "description": "Unexpected error"
          }
        },
        "summary": "Get performance trend data of a filesystem identified by {filesystemId} on a HPE Alletra Storage X10000 system",
        "tags": [
          "file-systems"
        ]
      }
    }
  },
  "components": {
    "parameters": {
      "fileshareUid": {
        "description": "Unique identifier of the file share",
        "in": "path",
        "name": "fileShareId",
        "required": true,
        "schema": {
          "type": "string"
        }
      },
      "filesystemUid": {
        "description": "Unique identifier of the filesystem",
        "in": "path",
        "name": "filesystemId",
        "required": true,
        "schema": {
          "type": "string"
        }
      },
      "limit": {
        "description": "Number of items to return at a time",
        "example": 10,
        "in": "query",
        "name": "limit",
        "required": false,
        "schema": {
          "default": 100,
          "maximum": 5000,
          "minimum": 0,
          "type": "integer"
        }
      },
      "offset": {
        "description": "The offset of the first item in the collection to return",
        "example": 5,
        "in": "query",
        "name": "offset",
        "required": false,
        "schema": {
          "default": 0,
          "maximum": 100000,
          "minimum": 0,
          "type": "integer"
        }
      },
      "range": {
        "allowReserved": true,
        "description": "Defines the start and end time for the query.",
        "example": "startTime eq 1605063600 and endTime eq 1605186000",
        "in": "query",
        "name": "range",
        "schema": {
          "type": "string"
        }
      },
      "select": {
        "allowReserved": true,
        "description": "Query to select only the required parameters, separated by . if nested",
        "example": "id",
        "in": "query",
        "name": "select",
        "schema": {
          "type": "string"
        }
      },
      "sharesettingsUid": {
        "description": "Unique identifier of the file share-settings",
        "in": "path",
        "name": "sharesettingsId",
        "required": true,
        "schema": {
          "type": "string"
        }
      },
      "storageSystemUid": {
        "description": "systemId of the storage system",
        "in": "path",
        "name": "systemId",
        "required": true,
        "schema": {
          "type": "string"
        }
      },
      "timeIntervalMin": {
        "allowReserved": true,
        "description": "It defines granularity in minutes.",
        "example": 60,
        "in": "query",
        "name": "timeintervalmin",
        "schema": {
          "enum": [
            5,
            60,
            1440,
            10080
          ],
          "type": "integer"
        }
      }
    },
    "schemas": {
      "ArcusFileShare": {
        "description": "The response body for file share details.",
        "properties": {
          "accessIp": {
            "description": "Specifies the host IP address",
            "type": "string"
          },
          "commonResourceAttributes": {
            "$ref": "#/components/schemas/fileCommonResourceAttributes"
          },
          "createdAt": {
            "description": "Creation time",
            "properties": {
              "ms": {
                "type": "integer"
              },
              "tz": {
                "type": "string"
              }
            },
            "type": "object"
          },
          "customerId": {
            "description": "The identifier of the customer application",
            "type": "string"
          },
          "detailedState": {
            "description": "Filesystem detailed state",
            "example": "STATE_NORMAL",
            "type": "string"
          },
          "displayname": {
            "description": "Display name of the file share",
            "format": "string",
            "type": "string"
          },
          "fileSystem": {
            "properties": {
              "id": {
                "description": "An identifier for the resource",
                "type": "string"
              },
              "name": {
                "description": "A system specified name for the resource.",
                "type": "string"
              },
              "resourceUri": {
                "description": "The 'self' reference for this resource.",
                "type": "string"
              }
            },
            "type": "object"
          },
          "generation": {
            "description": "A monotonically increasing value. This value updates when the resource is updated and can be used as a short way to determine if a resource has changed or which of two different copies of a resource is more up to date.",
            "format": "int64",
            "readOnly": true,
            "type": "integer"
          },
          "id": {
            "description": "UID string uniquely identifying the file share object. `Filter`",
            "type": "string"
          },
          "name": {
            "description": "Specifies the name of the file share",
            "type": "string"
          },
          "path": {
            "description": "File share path",
            "type": "string"
          },
          "protocol": {
            "description": "Specifies the list of protocols that are enabled for this file share. For version 10.5.0 only NFSV4 protocol is supported.",
            "items": {
              "type": "string"
            },
            "type": "array"
          },
          "resourceUri": {
            "description": "Resource URI of the file share",
            "type": "string"
          },
          "settings": {
            "properties": {
              "id": {
                "description": "An identifier for the resource",
                "type": "string"
              },
              "name": {
                "description": "A system specified name for the resource.",
                "type": "string"
              },
              "resourceUri": {
                "description": "The 'self' reference for this resource.",
                "type": "string"
              }
            },
            "type": "object"
          },
          "shareId": {
            "description": "Numeric ID of the resource",
            "format": "int64",
            "type": "integer"
          },
          "state": {
            "description": "Specifies the state of the file share",
            "example": "UNKNOWN",
            "type": "string"
          },
          "systemId": {
            "description": "SystemUid of the storage system.",
            "example": "7CE751P312",
            "type": "string"
          },
          "systemWwn": {
            "description": "System WWN of the array.",
            "example": "7CE751P312",
            "type": "string"
          },
          "type": {
            "description": "The type of resource.",
            "readOnly": true,
            "type": "string"
          }
        },
        "required": [
          "id",
          "type"
        ],
        "title": "File share details",
        "type": "object"
      },
      "ArcusFileShareDetails": {
        "allOf": [
          {
            "$ref": "#/components/schemas/ArcusFileShare"
          }
        ],
        "description": "Arcus file-share detail",
        "properties": {},
        "type": "object"
      },
      "ArcusFileSystemDetail": {
        "allOf": [
          {
            "$ref": "#/components/schemas/ArcusFilesystem"
          }
        ],
        "description": "Arcus filesystem detail",
        "properties": {
          "filesystemCapacity": {
            "$ref": "#/components/schemas/ArcusFilesystemCapacity"
          },
          "filesystemPerformance": {
            "$ref": "#/components/schemas/ArcusFilesystemPerformance"
          }
        },
        "type": "object"
      },
      "ArcusFileshareList": {
        "properties": {
          "count": {
            "description": "Number of items in this response.",
            "type": "integer"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/ArcusFileShare"
            },
            "type": "array"
          },
          "offset": {
            "description": "The offset query parameter from the request.",
            "type": "integer"
          },
          "total": {
            "description": "Total number of items matching the filter parameter in the request.",
            "type": "integer"
          }
        },
        "required": [
          "count",
          "offset",
          "items"
        ],
        "type": "object"
      },
      "ArcusFilesystem": {
        "properties": {
          "commonResourceAttributes": {
            "$ref": "#/components/schemas/fileCommonResourceAttributes"
          },
          "createdAt": {
            "description": "Creation time",
            "properties": {
              "ms": {
                "type": "integer"
              },
              "tz": {
                "type": "string"
              }
            },
            "type": "object"
          },
          "customerId": {
            "description": "The identifier of the customer application",
            "type": "string"
          },
          "detailedState": {
            "description": "Filesystem detailed state",
            "example": "STATE_NORMAL",
            "type": "string"
          },
          "filesystemId": {
            "description": "filesystem ID",
            "example": 1,
            "type": "integer"
          },
          "filesystemType": {
            "description": "Filesystem type",
            "example": "XFS",
            "type": "string"
          },
          "fsmaster": {
            "description": "Master node (owner) of the filesystem.",
            "example": 1,
            "type": "integer"
          },
          "generation": {
            "description": "A monotonically increasing value. This value updates when the resource is updated and can be used as a short way to determine if a resource has changed or which of two different copies of a resource is more up to date.",
            "format": "int64",
            "readOnly": true,
            "type": "integer"
          },
          "id": {
            "description": "Unique identifier of the Filesystem",
            "example": "7CE751P312",
            "type": "string"
          },
          "isCompressionEnabled": {
            "description": "Specifies if compression is enabled on this filesystem.",
            "example": true,
            "type": "boolean"
          },
          "isDedupeEnabled": {
            "description": "Specifies if deduplication is enabled on this filesystem.",
            "example": true,
            "type": "boolean"
          },
          "isReductionEnabled": {
            "description": "Specifies if data reduction is enabled on this filesystem.",
            "example": true,
            "type": "boolean"
          },
          "name": {
            "description": "Filesystem name",
            "example": "FS1",
            "type": "string"
          },
          "prov": {
            "description": "Provisioning type",
            "example": "tdvv",
            "type": "string"
          },
          "replicant": {
            "description": "First failover node of the filesystem.",
            "example": 1,
            "type": "integer"
          },
          "replicant2": {
            "description": "Second failover node of the filesystem.",
            "example": 1,
            "type": "integer"
          },
          "replicant3": {
            "description": "Third failover node of the filesystem.",
            "example": 1,
            "type": "integer"
          },
          "resourceUri": {
            "description": "Resource URI of the filesystem",
            "type": "string"
          },
          "shareCount": {
            "description": "Number of shares associated with the filesystem",
            "example": 1,
            "type": "integer"
          },
          "state": {
            "description": "Filesystem state",
            "example": "NORMAL",
            "type": "string"
          },
          "systemId": {
            "description": "SystemUid of the storage system.",
            "example": "7CE751P312",
            "type": "string"
          },
          "systemWwn": {
            "description": "WWN of Storage System",
            "example": "7CE751P312",
            "type": "string"
          },
          "type": {
            "description": "The type of resource.",
            "readOnly": true,
            "type": "string"
          },
          "volumeDetails": {
            "items": {
              "$ref": "#/components/schemas/VolumeDetails"
            },
            "type": "array"
          }
        },
        "required": [
          "id",
          "type"
        ],
        "type": "object"
      },
      "ArcusFilesystemCapacity": {
        "description": "Arcus filesystem capacity detail",
        "properties": {
          "compressionRatio": {
            "description": "Compression ratio",
            "format": "float64",
            "type": "number"
          },
          "freeSizeInMiB": {
            "description": "Filesystem free size in MiB",
            "format": "float64",
            "type": "number"
          },
          "savingsRatio": {
            "description": "Savings ratio",
            "format": "float64",
            "type": "number"
          },
          "sizeInMiB": {
            "description": "Filesystem total size in MiB",
            "format": "float64",
            "type": "number"
          },
          "usedCapacityPercentage": {
            "description": "Filesystem used capacity percentage",
            "format": "float64",
            "type": "number"
          },
          "usedSizeInMiB": {
            "description": "Filesystem used size in MiB",
            "format": "float64",
            "type": "number"
          },
          "vvSizeInMiB": {
            "description": "Volume size in MiB",
            "example": 100,
            "format": "float64",
            "type": "number"
          }
        },
        "type": "object"
      },
      "ArcusFilesystemPerformance": {
        "description": "Filesystem performance details",
        "properties": {
          "iops": {
            "properties": {
              "read": {
                "$ref": "#/components/schemas/ArcusPerformanceDetail"
              },
              "total": {
                "$ref": "#/components/schemas/ArcusPerformanceDetail"
              },
              "write": {
                "$ref": "#/components/schemas/ArcusPerformanceDetail"
              }
            },
            "type": "object"
          },
          "latencyMs": {
            "properties": {
              "read": {
                "$ref": "#/components/schemas/ArcusPerformanceDetail"
              },
              "total": {
                "$ref": "#/components/schemas/ArcusPerformanceDetail"
              },
              "write": {
                "$ref": "#/components/schemas/ArcusPerformanceDetail"
              }
            },
            "type": "object"
          },
          "throughputKbps": {
            "properties": {
              "read": {
                "$ref": "#/components/schemas/ArcusPerformanceDetail"
              },
              "total": {
                "$ref": "#/components/schemas/ArcusPerformanceDetail"
              },
              "write": {
                "$ref": "#/components/schemas/ArcusPerformanceDetail"
              }
            },
            "type": "object"
          }
        },
        "type": "object"
      },
      "ArcusFilesystemsList": {
        "properties": {
          "count": {
            "description": "Number of items in this response.",
            "type": "integer"
          },
          "items": {
            "items": {
              "$ref": "#/components/schemas/ArcusFilesystem"
            },
            "type": "array"
          },
          "offset": {
            "description": "The offset query parameter from the request.",
            "type": "integer"
          },
          "total": {
            "description": "Total number of items matching the filter parameter in the request.",
            "type": "integer"
          }
        },
        "required": [
          "count",
          "offset",
          "items"
        ],
        "type": "object"
      },
      "ArcusPerformanceDetail": {
        "properties": {
          "avgOf1day": {
            "description": "last one day average data",
            "format": "float64",
            "type": "number"
          },
          "avgOf1hour": {
            "description": "last one hour average data",
            "format": "float64",
            "type": "number"
          },
          "avgOf8hours": {
            "description": "last 8 hours average data",
            "format": "float64",
            "type": "number"
          },
[...]
